<template>
  <div>
    <el-row class="item-row" type="flex" align="middle" :gutter="10" justify="space-between">
      <el-col :span="2">
        <el-form-item label="Categoría" />
      </el-col>
      <el-col :span="6">
        <el-form-item label="Producto" />
      </el-col>
      <el-col :span="2">
        <el-form-item label="P. Unit" />
      </el-col>
      <el-col :span="1">
        <el-form-item label="Vend.">
          {{ totalSales }}
        </el-form-item>
      </el-col>
      <el-col :span="2">
        <el-form-item label="Pedidos">
          {{ totalRequests }}
        </el-form-item>
      </el-col>
      <el-col :span="2">
        <el-form-item label="Bonif.">
          {{ totalBonifieds }}
        </el-form-item>
      </el-col>
      <el-col :span="2">
        <el-form-item label="Imp. Total">
          {{ totalCharged | formatCurrency }}
        </el-form-item>
      </el-col>
      <el-col :span="2">
        <el-form-item label="Descuento">
          {{ totalDiscount | formatCurrency }}
        </el-form-item>
      </el-col>
      <el-col :span="6">
      </el-col>
    </el-row>

    <el-row class="item-row" type="flex" align="middle" :gutter="10" justify="space-between"
            v-for="(item, idx) in displayItems"
            :class="{'even': idx % 2 === 0, 'odd': idx % 2 !== 0}"
            :idx="idx" :key="item.productId">
      <el-col :span="2">
        {{ item.category }}
      </el-col>
      <el-col :span="6">
        {{ item.name }}
      </el-col>
      <el-col :span="2">
        <el-input
          @input="update(idx, 'unitPrice', $event)"
          class="unit-price" type="number"
          :value="item.unitPrice" min="0">
          <template slot="prepend">$</template>

          <font-awesome-icon class="light-grey" icon="cube" slot="suffix" />
        </el-input>
      </el-col>
      <el-col :span="1">
        {{ item.sales }}
        <font-awesome-icon class="green" icon="hand-holding-usd" />
      </el-col>
      <el-col :span="2">
        <el-input
          @input="update(idx, 'requests', $event)"
          type="number" :value="item.requests" min="0">
          <font-awesome-icon class="light-blue" slot="suffix" icon="truck" />
        </el-input>
      </el-col>
      <el-col :span="2">
        <el-input
          @input="update(idx, 'bonifieds', $event)"
          type="number" :value="item.bonifieds" min="0">
          <font-awesome-icon class="tiffany" slot="suffix" icon="gift" />
        </el-input>
      </el-col>
      <el-col :span="2">
        {{ item.totalCharged | formatCurrency }}
        <font-awesome-icon class="light-grey" icon="cubes" />
      </el-col>
      <el-col :span="2">
        {{ item.discount | formatCurrency }}
        <font-awesome-icon class="pink" icon="cubes" />
      </el-col>
      <el-col :span="6">
        <app-order-buttons
          @request="addRequest(idx, $event)"
          @bonified="addBonified(idx, $event)"
        />
      </el-col>
    </el-row>
  </div>
</template>

<script>
import api from "@/feathers";
import AppOrderButtons from "@/common/order-buttons";

export default {
  name: "app-items-table",
  components: {
    AppOrderButtons
  },
  props: {
    items: { required: true, type: Array },
    discount: { required: true, type: Number },
    selectedPrice: { required: true, type: String, default: "price" }
  },
  model: {
    prop: "items",
    event: "update"
  },
  data() {
    return {
      products: []
    };
  },
  async created() {
    this.productsService = api.service("products");
    this.products = await this.productsService.find({ query: { $limit: -1 } });
  },
  computed: {
    displayItems: {
      get: function() {
        return this.products
          .map(product => this.getDisplayItemDefaults(product))
          .map(defaultItem => {
            const matchingItems = this.items.filter(
              item => defaultItem.productId === item.product
            );
            matchingItems.forEach(matchingItem => {
              if (matchingItem.isReturn) {
                defaultItem.bonifieds = matchingItem.quantity;
              } else {
                defaultItem.requests = matchingItem.quantity;
              }
            });
            return defaultItem;
          })
          .map(item => {
            item.sales = item.requests - item.bonifieds;
            return item;
          })
          .map(item => {
            item.totalCharged = item.unitPrice * item.sales;
            return item;
          })
          .map(item => {
            item.discount = (item.totalCharged * this.discount) / 100;
            return item;
          });
      },
      set: function(displayItems) {
        const requests = displayItems
          .filter(item => item.requests > 0)
          .map(item => ({
            isReturn: false,
            product: item.productId,
            quantity: item.requests,
            unitPrice: item.unitPrice
          }));
        const bonifieds = displayItems
          .filter(item => item.bonifieds > 0)
          .map(item => ({
            isReturn: true,
            product: item.productId,
            quantity: item.bonifieds,
            unitPrice: item.unitPrice
          }));
        const items = requests.concat(bonifieds);
        this.$emit("update", items);
      }
    },
    totalSales() {
      return this.displayItems.reduce((accumulated, currentItem) => {
        return accumulated + Number(currentItem.sales);
      }, 0);
    },
    totalRequests() {
      return this.displayItems.reduce((accumulated, currentItem) => {
        return accumulated + Number(currentItem.requests);
      }, 0);
    },
    totalBonifieds() {
      return this.displayItems.reduce((accumulated, currentItem) => {
        return accumulated + Number(currentItem.bonifieds);
      }, 0);
    },
    totalCharged() {
      return this.displayItems.reduce((accumulated, currentItem) => {
        return accumulated + currentItem.sales * currentItem.unitPrice;
      }, 0);
    },
    totalDiscount() {
      return this.displayItems.reduce((accumulated, currentItem) => {
        return accumulated + currentItem.discount;
      }, 0);
    }
  },
  methods: {
    _updateIfPositive(initialValue, add) {
      if (initialValue + add >= 0) {
        return Number(initialValue) + add;
      } else {
        return initialValue;
      }
    },
    addRequest(idx, add) {
      const item = this.displayItems[idx];
      item.requests = this._updateIfPositive(item.requests, add);
      this.displayItems = this.displayItems.slice(0);
      // WARNING!: Vue reactivity is a trap!!!!, it doesn't work like
      // is documented for computed, that was the only way I found to
      // get the reactivity
    },
    addBonified(idx, add) {
      const item = this.displayItems[idx];
      item.requests = this._updateIfPositive(item.requests, add);
      item.bonifieds = this._updateIfPositive(item.bonifieds, add);
      this.displayItems = this.displayItems.slice(0);
      // WARNING!: Vue reactivity is a trap!!!!, $set doesn't work
      // for computed, that was the only way I found to get the
      // reactivity
    },
    getDisplayItemDefaults(product) {
      const price = product[this.selectedPrice] || product.price;
      return {
        productId: product._id,
        category: product.category,
        name: product.name,
        unitPrice: price.toFixed(2),
        sales: 0,
        requests: 0,
        bonifieds: 0,
        discount: 0,
        totalCharged: 0
      };
    },
    update(idx, propName, value) {
      const item = this.displayItems[idx];
      item[propName] = value;
      this.displayItems = this.displayItems.slice(0);
    }
  }
};
</script>


<style lang="scss">
.item-row {
  &.even {
    background-color: #f3f7fd;
  }
  text-align: center;
  padding-top: 6px;
  padding-bottom: 6px;

  .el-input {
    width: 80%;
  }
  .el-input__suffix {
    line-height: 40px;
  }
}

input[type="number"]::-webkit-outer-spin-button,
input[type="number"]::-webkit-inner-spin-button {
  -webkit-appearance: none;
  margin: 0;
}

input[type="number"] {
  -moz-appearance: textfield;
}

.unit-price {
  .el-input-group__prepend {
    padding: 2px;
  }
}
</style>
